<!DOCTYPE html>
<html>
<head>
    <title>Clocks</title>
    <script>
        var flick_mapping = {
            "flicklib.flick.toleft": {"action_data": "${web_local_root}/weather.html", "action_type": "pyppe.goto"},
            "flicklib.flick.toright": {"action_data": "${web_local_root}/calendar.html", "action_type": "pyppe.goto"},
            "flicklib.flick.up": {"action_data": "${web_local_root}/gallery.html", "action_type": "pyppe.goto"}
        }


        function start() {
            clock()
            date()
        }

        function clock() {
            clock_root_el = document.getElementById('clock_display')

            const today = new Date();
            let h = today.getHours();
            let m = today.getMinutes();
            let s = today.getSeconds();
            m = checkTime(m);
            s = checkTime(s);
            /*ocument.getElementById('clock_display').innerHTML =  h + ":" + m + ":" + s;*/
            get_current_clock_vals(clock_root_el, h, m, s)
            setTimeout(clock, 1000);
        }

        function date() {
            date_root_el = document.getElementById('date_display');
            const today = new Date();
            let y = today.getFullYear();
            let mo = today.getMonth();
            let date = today.getDate();
            let day_of_week = today.getDay();
            set_currentdate_vals(date_root_el,day_of_week, date, mo, y)
            setTimeout(date, 3600 * 1000)
        }

        function set_currentdate_vals(root_el, day,date, mo, y) {
            day_el = root_el.firstElementChild;

            date_el = day_el.nextElementSibling;

            month_el = date_el.nextElementSibling;

            year_el = month_el.nextElementSibling;

            if (day_el.innerHTML != day) {
                _redraws_clock_element(day_el, day)
            }
            if (date_el.innerHTML != date) {
                _redraws_clock_element(date_el, date)
            }
            if (month_el.innerHTML != mo) {
                _redraws_clock_element(month_el, mo)
            }
            if (year_el.innerHTML != y) {
                _redraws_clock_element(year_el, y)
            }
        }
        function get_current_clock_vals(root_el, next_hour, next_min, next_sec) {
            hour_el = root_el.firstElementChild;

            min_el = hour_el.nextElementSibling;

            sec_el = root_el.lastElementChild;

            if (parseInt(sec_el.innerHTML) !=  next_sec) {                
                _redraws_clock_element(sec_el, next_sec)               
            }
            if (parseInt(min_el.innerHTML) !=  next_min) {                
                _redraws_clock_element(min_el, next_min)               
            }
            if (parseInt(hour_el.innerHTML) !=  next_hour) {                
                _redraws_clock_element(hour_el, next_hour)               
            }
        }

        function _redraws_clock_element(el, value){
            el.classList.add("transition-opacity");
                setTimeout(function() {
                    el.innerHTML = value;
                    el.classList.remove("transition-opacity");
                }, 800)
        }

        function checkTime(i) {
            if (i < 10) {i = "0" + i};  // add zero in front of numbers < 10
            return i;
        }

    </script>
    <link href="res/css/default.css" rel="stylesheet">
</head>
<body onload="start()">
    <div id="main_content">
        <div class ="row" style="height: 400px;">
       <div id="clock_pane">
        <h3 id="clock_display">
            <span class="full-opacity">00</span>:<span class="full-opacity">00</span>:<span class="full-opacity">00</span>
        </h3>
        <h4 id="date_display">  
            <span class="full-opacity">None</span> <span class="full-opacity">00</span>.<span class="full-opacity">00</span>.<span class="full-opacity">0000</span>
        </h4>
       </div>
       <div id="left_weather_pane">
        <h4 style="padding:10px">Weather by Day</h4>
        <div class="card">
            <p>Tomorrow</p>
        </div>
        <div class="card">
            <p>after Tomorrow</p>
        </div>
       </div>
    </div>
    <div class="row" style="width:100%, height:300px">
    <h3 style="text-align: center;">weather per hour.</h3>
    </div>
    </div>
</body>
</html>